import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CourseCategory, CourseCategoryParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询课程分类
 */
export async function pageCourseCategory(params: CourseCategoryParam) {
  const res = await request.get<ApiResult<PageResult<CourseCategory>>>(
    MODULES_API_URL + '/booking/course-category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询课程分类列表
 */
export async function listCourseCategory(params?: CourseCategoryParam) {
  const res = await request.get<ApiResult<CourseCategory[]>>(
    MODULES_API_URL + '/booking/course-category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加课程分类
 */
export async function addCourseCategory(data: CourseCategory) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改课程分类
 */
export async function updateCourseCategory(data: CourseCategory) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除课程分类
 */
export async function removeCourseCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course-category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除课程分类
 */
export async function removeBatchCourseCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/course-category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询课程分类
 */
export async function getCourseCategory(id: number) {
  const res = await request.get<ApiResult<CourseCategory>>(
    MODULES_API_URL + '/booking/course-category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
